/*****************************************************************************
 *
 * include/xen/viridian.h
 *
 * Copyright (c) 2008 Citrix Corp.
 *
 */

#ifndef __VIRIDIAN_H__
#define __VIRIDIAN_H__

typedef union
{
    uint64_t    raw;
    struct
    {
        uint64_t    build_number:16;
        uint64_t    service_pack:8;
        uint64_t    minor:8;
        uint64_t    major:8;
        uint64_t    os:8;
        uint64_t    vendor:16;
    }           fields;
} viridian_guest_os_id;

typedef union
{   uint64_t    raw;
    struct
    {
        uint64_t    enabled:1;
        uint64_t    reserved_preserved:11;
        uint64_t    pfn:48;
    }           fields;
} viridian_hypercall_gpa;


struct viridian_domain
{
    viridian_guest_os_id    guest_os_id;
    viridian_hypercall_gpa  hypercall_gpa;
};

int
cpuid_viridian_leaves(unsigned int leaf,
                      unsigned int *eax,
                      unsigned int *ebx,
                      unsigned int *ecx,
                      unsigned int *edx);

int
wrmsr_viridian_regs(uint32_t idx,
                    uint32_t eax,
                    uint32_t edx);

int
rdmsr_viridian_regs(uint32_t idx,
                    uint32_t *eax,
                    uint32_t *edx);

int
viridian_hypercall(struct cpu_user_regs *regs);

#endif
