/*
 * SDL_zoom - surface scaling
 * 
 * Derived from: SDL_rotozoom,  LGPL (c) A. Schiffler
 * from the SDL_gfx library.
 *
 * Modifications by Christopher Clark (c) 2007 XenSource Inc.
 */

#ifndef _SDL_zoom_h
#define _SDL_zoom_h

#include <SDL.h>

#define SMOOTHING_OFF		0
#define SMOOTHING_ON		1

typedef struct tColorRGBA {
    Uint8 r;
    Uint8 g;
    Uint8 b;
    Uint8 a;
} tColorRGBA;

typedef struct tColorY {
    Uint8 y;
} tColorY;


int sdl_zoom_blit(SDL_Surface *src_sfc, SDL_Surface *dst_sfc,
                  int smooth, SDL_Rect *src_rect);

#endif /* _SDL_zoom_h */
